#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <sstream>
#include <queue>
#include <bitset>
#include <utility>
#include <list>
#include <numeric>

#include <cstdio>
#include <cmath>
#include <cctype>
using namespace std;

#define REP(i,n) for(__typeof(n) i=0; i<(n); ++i)
#define FOR(i,a,b) for(__typeof(b) i=a; i<(b); ++i)
#define FOREACH(it,c) for(__typeof((c).begin()) it=(c).begin(); it!=(c).end(); ++it)

typedef long long ll;
typedef pair<int, int> PI;
int n;
int f(int a) {
    return a%n;
}
int poc(vector<int> &a, int z, int k) {
    if (z<=k) return a[k+1]-a[z];
    else return a[n]-a[z]+a[k+1];
}
int k[1010][1010];
int main() {
    char c[1010], d[1010];

    vector<int> a[3], w[3], v[3];
    REP(i,3) a[i]=w[i]=vector<int>(1010);
    char u[256]={0};
    u[(int)'G']=0; u[(int)'S']=1; u[(int)'B']=2;
    REP(i,1010) k[0][i]=0;
    string h = "GSB";

    scanf("%d", &n);
    scanf("%s", c);
    scanf("%s", d);
    if (strlen(c) != n || strlen(d) != n || n<1 || n>1000) {
        printf("Wrong length of input");
        return 1;
    }

    REP(i,3) {
        fill(w[i].begin(), w[i].begin()+n, 0);
        fill(a[i].begin(), a[i].begin()+n, 0);
        v[i] = vector<int>();
    }

    FOR(i,1,n+1) {
        REP(j,3) a[j][i]=a[j][i-1];
        a[u[(int)c[i-1]]][i]++;
        REP(j,3) w[j][i]=w[j][i-1];
        w[u[(int)d[i-1]]][i]++;
    }

    for (int i=0; i<n; i++)
        v[u[int(d[i])]].push_back(i);

    REP(i,3)
        if (v[i].size() != w[i][n]) {
            printf("Wrong number of beads of color %d. There will be no solution.", i);
            return 1;
        }

    FOR(j,1,n+1) REP(i,n) {
        k[j][i]=n+47;
        REP(q,2) {
            int y=k[j-1][f(i+q)]+j;
            if (y>=n) {
                k[j][i]=min(k[j][i], k[j-1][f(i+q)]);
                continue;
            }

            int r[3]={0};
            int l=f(i+j-1);
            REP(z,3)
                for (int k = 0; k<j; k++) {
                    int kk = (i+k)%n;
                    if (c[kk] == h[z]) r[z]++;
                }

            if (q==1) l=i;

            int x = u[(int)c[l]];

            if (r[x] <= w[x][y])
                k[j][i]=min(k[j][i], k[j-1][f(i+q)]);
            else
                k[j][i]=min(k[j][i], max(k[j-1][f(i+q)], v[x][r[x]-1]+1-j) );
        }
    }

    int res=n+47;
    REP(i,n) res=min(res, k[n][i]);
    printf("%d\n", res);
}
